package main

import (
	"flag"
	"io/ioutil"
	"log"
	"os"
)

func main() {
	inFile := flag.String("input", "", "")
	flag.Parse()

	if *inFile == "" {
		flag.Usage()
		os.Exit(1)
	}

	// Read input file
	content, err := ioutil.ReadFile(*inFile)
	if err != nil {
		log.Fatal(err)
	}

	// Parse input file
	mn, err := ParseBNF(content)
	if err != nil {
		log.Fatal("ParseBNF: " + err.Error())
	}

	// Generate Plexus alternative
	pv, err := Convert(mn)
	if err != nil {
		log.Fatal("Convert: " + err.Error())
	}

	// Write out as Go source
	err = pv.LowerToGoSource(os.Stdout)
	if err != nil {
		log.Fatal("LowerToGoSource: " + err.Error())
	}

	// Done
}
