package main

import (
	"testing"

	p "code.ivysaur.me/plexus"
)

func TestBNFParse(t *testing.T) {
	mn, err := ParseBNF([]byte(`
#comment

foo : bar 'baz'
	`))

	if err != nil {
		t.Log(err)
		t.Fail()
	}

	expected := p.MatchNode{Type: RULE_DOCUMENT, Children: []p.MatchNode{
		p.MatchNode{Type: RULE_DOCUMENT_ENTRY, Children: []p.MatchNode{
			p.MatchNode{Type: RULE_COMMENT_LINE, Children: []p.MatchNode{
				p.Literal("#comment\n"),
			}},
		}},
		p.MatchNode{Type: RULE_DOCUMENT_ENTRY, Children: []p.MatchNode{
			p.MatchNode{Type: RULE_EXPRESSION, Children: []p.MatchNode{
				p.MatchNode{Type: RULE_IDENTIFIER, Children: []p.MatchNode{
					p.Literal("foo"),
				}},
				p.Literal(":"),
				p.MatchNode{Type: RULE_ARGLIST, Children: []p.MatchNode{
					p.MatchNode{Type: RULE_SINGLE_ARG_ELEMENT, Children: []p.MatchNode{
						p.MatchNode{Type: RULE_IDENTIFIER, Children: []p.MatchNode{
							p.Literal("bar"),
						}},
					}},
					p.MatchNode{Type: RULE_SINGLE_ARG_ELEMENT, Children: []p.MatchNode{
						p.MatchNode{Type: 2, Children: []p.MatchNode{
							p.Literal("'baz'"),
						}},
					}},
				}},
			}},
		}},
	}}

	if !mn.Equals(&expected) {
		t.Log("Unexpected parse result")
		t.Fail()
	}
}
