package main

import (
	"fmt"
	"io"
	"strings"
)

func (this *PlexusVersion) LowerToGoSource(w io.Writer) error {
	fmt.Fprint(w, `// AUTOGENERATED, DO NOT EDIT

package main

import (
	p "code.ivysaur.me/plexus"
)

const (
`)

	first := false
	for _, entry := range this.rules {
		if first {
			fmt.Fprintf(w, "\t%s p.MatchType = iota\n", entry.name)
		} else {
			fmt.Fprintf(w, "\t%s\n", entry.name)
		}
	}

	fmt.Fprintf(w, `
)

// ParseContent parses supplied content using the predefined language grammar.
func ParseContent(content []byte) (*p.MatchNode, error) {
	
	pa := p.ParseAttempt{
		Syntax: p.SyntaxTree{
`)

	for _, entry := range this.rules {
		fmt.Fprintf(w, "\t\t\t%s: []p.MatchNode{%s},\n", entry.name, strings.Join(entry.insert, ", "))
	}

	fmt.Fprint(w, `
		},
	}
	
	mn, err := pa.Parse(RULE_DOCUMENT, input)
	if err != nil {
		return nil, err
	}

	return mn, nil
}
`)

	return nil
}
